Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 589921 - bad dwarf cfi data in wget binary
Summary: bad dwarf cfi data in wget binary
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: wget
Version: 6.0
Hardware: All
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Karsten Hopp
QA Contact: Michal Nowak
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-05-07 10:07 UTC by Mark Wielaard
Modified: 2013-03-08 02:09 UTC (History)
3 users (show)

Fixed In Version: wget-1.12-1.4.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-11-10 21:54:56 UTC
Target Upstream Version:


Attachments (Terms of Use)
python script to check for bad cfi in a binary (deleted)
2010-05-07 10:28 UTC, Mark Wielaard
no flags Details

Description Mark Wielaard 2010-05-07 10:07:49 UTC
Description of problem:

An old version of gcc generated bad dwarf cfi expressions. This would not impact the functioning of the package itself, but might make debugging the binary with gdb, or tracing with systemtap less practical. This isn't a very high priority. But if the package can be rebuild with a current toolchain, gcc-4.4.3-19.el6 or later, that would solve this issue. Background information: http://gcc.gnu.org/ml/gcc-patches/2010-04/msg01422.html This only affects a very small number of packages (and only the i686 binaries).

Version-Release number of selected component (if applicable):

wget-1.12-1.3.el6.i686 (/usr/bin/wget)

The attached check_cfi.py script (thanks to Petr Machata) can be used to check the output of readelf --debug-dump=frames to see whether the faulty dwarf cfi expressions are present in the binary. There should be no output, currently the output is:

readelf --debug-dump=frames /usr/bin/wget | tail -n +3 | python check_cfi.py
['00000000', '00000014', '00000000', 'CIE']
   DW_CFA_def_cfa: r4 (esp) ofs 4
   DW_CFA_offset: r8 (eip) at cfa-4
   DW_CFA_nop
   DW_CFA_nop
['00002d68', '00000044', '00002d6c', 'FDE', 'cie=00000000', 'pc=08065b80..08066f2d']
   DW_CFA_advance_loc: 4 to 08065b84
>  DW_CFA_def_cfa: r1 (ecx) ofs 0
   DW_CFA_advance_loc: 9 to 08065b8d
   DW_CFA_expression: r5 (ebp) (DW_OP_breg5: 0)
   DW_CFA_advance_loc: 4 to 08065b91
>  DW_CFA_def_cfa_expression (DW_OP_breg5: -16; DW_OP_deref)
   DW_CFA_advance_loc: 58 to 08065bcb
   DW_CFA_expression: r3 (ebx) (DW_OP_breg5: -12)
   DW_CFA_expression: r6 (esi) (DW_OP_breg5: -8)
   DW_CFA_expression: r7 (edi) (DW_OP_breg5: -4)
   DW_CFA_advance_loc2: 3103 to 080667ea
   DW_CFA_remember_state
>  DW_CFA_def_cfa_register: r1 (ecx)
   DW_CFA_advance_loc: 1 to 080667eb
   DW_CFA_restore: r3 (ebx)
   DW_CFA_advance_loc: 1 to 080667ec
   DW_CFA_restore: r6 (esi)
   DW_CFA_advance_loc: 1 to 080667ed
   DW_CFA_restore: r7 (edi)
   DW_CFA_advance_loc: 1 to 080667ee
   DW_CFA_restore: r5 (ebp)
   DW_CFA_advance_loc: 3 to 080667f1
   DW_CFA_def_cfa: r4 (esp) ofs 4
   DW_CFA_advance_loc: 1 to 080667f2
   DW_CFA_restore_state
   DW_CFA_nop
   DW_CFA_nop
   DW_CFA_nop
error in instr #16, DW_CFA_def_cfa_register

Comment 1 Mark Wielaard 2010-05-07 10:28:52 UTC
Created attachment 412297 [details]
python script to check for bad cfi in a binary

Comment 2 RHEL Product and Program Management 2010-05-07 11:31:12 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux major release.  Product Management has requested further
review of this request by Red Hat Engineering, for potential inclusion in a Red
Hat Enterprise Linux Major release.  This request is not yet committed for
inclusion.

Comment 5 releng-rhel@redhat.com 2010-11-10 21:54:56 UTC
Red Hat Enterprise Linux 6.0 is now available and should resolve
the problem described in this bug report. This report is therefore being closed
with a resolution of CURRENTRELEASE. You may reopen this bug report if the
solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.